Debian Bug report logs - #377618
logcheck: Please do not abuse debconf

version graph

Package: logcheck; Maintainer for logcheck is Debian logcheck Team <logcheck-devel@lists.alioth.debian.org>; Source for logcheck is src:logcheck.

Reported by: Thomas Huriaux <thomas.huriaux@gmail.com>

Date: Mon, 10 Jul 2006 11:48:23 UTC

Severity: wishlist

Fixed in version logcheck/1.2.48

Done: madduck@debian.org (martin f. krafft)

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian logcheck Team <logcheck-devel@lists.alioth.debian.org>:
Bug#377618; Package logcheck. Full text and rfc822 format available.

Acknowledgement sent to Thomas Huriaux <thomas.huriaux@gmail.com>:
New Bug report received and forwarded. Copy sent to Debian logcheck Team <logcheck-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Thomas Huriaux <thomas.huriaux@gmail.com>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: logcheck: Please do not abuse debconf
Date: Mon, 10 Jul 2006 13:32:46 +0200
[Message part 1 (text/plain, inline)]
Package: logcheck
Severity: minor

Hi,

You are using two debconf notes which really look like a debconf abuse
(from debconf-devel(7): "It should be used only for important notes that
the user really should see, since debconf will go to great pains to make
sure the user sees it").

The first note (logcheck/install-note) should probably be moved to a
README.Debian file or somewhere else in the documentation. Or you should
really use debconf to configure these two options (report level and
address) instead of displaying a note.
The second note (logcheck/changes) can probably be removed. It no longer
concerns supported transitions in Debian: the version 1.2.39 is in
sarge, and if I understand correctly, it is for transitions from a
version < 1.2.3. However, this note should have been in a NEWS.Debian
file.

Cheers,

-- 
Thomas Huriaux
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian logcheck Team <logcheck-devel@lists.alioth.debian.org>:
Bug#377618; Package logcheck. Full text and rfc822 format available.

Acknowledgement sent to maximilian attems <maks@sternwelten.at>:
Extra info received and forwarded to list. Copy sent to Debian logcheck Team <logcheck-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #10 received at 377618@bugs.debian.org (full text, mbox):

From: maximilian attems <maks@sternwelten.at>
To: Thomas Huriaux <thomas.huriaux@gmail.com>, 377618@bugs.debian.org
Subject: Re: [Logcheck-devel] Bug#377618: logcheck: Please do not abuse debconf
Date: Thu, 20 Jul 2006 10:51:59 +0200
On Mon, 10 Jul 2006, Thomas Huriaux wrote:

> Hi,
> 
> You are using two debconf notes which really look like a debconf abuse
> (from debconf-devel(7): "It should be used only for important notes that
> the user really should see, since debconf will go to great pains to make
> sure the user sees it").
> 
> The first note (logcheck/install-note) should probably be moved to a
> README.Debian file or somewhere else in the documentation. Or you should
> really use debconf to configure these two options (report level and
> address) instead of displaying a note.

debconf notes are usually more effective than README's,
also the note is _only_ displayed at level medium so i fail to see the
abuse of the install-note.

> The second note (logcheck/changes) can probably be removed. It no longer
> concerns supported transitions in Debian: the version 1.2.39 is in
> sarge, and if I understand correctly, it is for transitions from a
> version < 1.2.3. However, this note should have been in a NEWS.Debian
> file.

it only shows up on upgrades and will be removed postetch.
currently we may wish to backport latest etch, so such upgrade
handling must stay.

-- 
maks



Information forwarded to debian-bugs-dist@lists.debian.org, Debian logcheck Team <logcheck-devel@lists.alioth.debian.org>:
Bug#377618; Package logcheck. Full text and rfc822 format available.

Acknowledgement sent to Thomas Huriaux <thomas.huriaux@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian logcheck Team <logcheck-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #15 received at 377618@bugs.debian.org (full text, mbox):

From: Thomas Huriaux <thomas.huriaux@gmail.com>
To: maximilian attems <maks@sternwelten.at>
Cc: 377618@bugs.debian.org, control@bugs.debian.org
Subject: Re: [Logcheck-devel] Bug#377618: logcheck: Please do not abuse debconf
Date: Thu, 20 Jul 2006 13:13:45 +0200
[Message part 1 (text/plain, inline)]
tag 377618 patch
thanks

maximilian attems <maks@sternwelten.at> (20/07/2006):
> On Mon, 10 Jul 2006, Thomas Huriaux wrote:
> > You are using two debconf notes which really look like a debconf abuse
> > (from debconf-devel(7): "It should be used only for important notes that
> > the user really should see, since debconf will go to great pains to make
> > sure the user sees it").
> > 
> > The first note (logcheck/install-note) should probably be moved to a
> > README.Debian file or somewhere else in the documentation. Or you should
> > really use debconf to configure these two options (report level and
> > address) instead of displaying a note.
> 
> debconf notes are usually more effective than README's,
> also the note is _only_ displayed at level medium so i fail to see the
> abuse of the install-note.

No, the argument of the priority is not valid. The lowest the priority
is, the more experienced the user is expected to be. An experienced user
usually knows where to find the relevant doc, and expects to find it at
the right place.
Moreover, as I said in my previous mail, you should use debconf to
_configure_ the package, not to tell the user he/she can configure it.
I therefore attach a patch to configure with debconf the two related
items. Please check it carefully as I made it quickly.


> > The second note (logcheck/changes) can probably be removed. It no longer
> > concerns supported transitions in Debian: the version 1.2.39 is in
> > sarge, and if I understand correctly, it is for transitions from a
> > version < 1.2.3. However, this note should have been in a NEWS.Debian
> > file.
> 
> it only shows up on upgrades and will be removed postetch.
> currently we may wish to backport latest etch, so such upgrade
> handling must stay.

Indeed, but once again, it should be in a NEWS.Debian file. Do not
forget that tools such as apt-listchanges display this kind of notes.



See also policy 3.9.1:

  Packages should try to minimize the amount of prompting they need to do

You seem to use debconf only because it is "more effective"


  Copyright messages do not count as vitally important [...] neither do
  instructions on how to use a program (these should be in on-line
  documentation, where all the users can see them).

The second template seems to concern only a new behavior of the package,
without needing the user to change anything to get it working. The first
one is exactly what is disrecommanded by this sentence.

-- 
Thomas Huriaux
[logcheck.diff (text/plain, attachment)]
[signature.asc (application/pgp-signature, inline)]

Tags added: patch Request was from Thomas Huriaux <thomas.huriaux@gmail.com> to control@bugs.debian.org. Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian logcheck Team <logcheck-devel@lists.alioth.debian.org>:
Bug#377618; Package logcheck. Full text and rfc822 format available.

Acknowledgement sent to maximilian attems <maks@sternwelten.at>:
Extra info received and forwarded to list. Copy sent to Debian logcheck Team <logcheck-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #22 received at 377618@bugs.debian.org (full text, mbox):

From: maximilian attems <maks@sternwelten.at>
To: Thomas Huriaux <thomas.huriaux@gmail.com>
Cc: 377618@bugs.debian.org
Subject: Re: [Logcheck-devel] Bug#377618: logcheck: Please do not abuse debconf
Date: Thu, 20 Jul 2006 13:38:28 +0200
tags 377618 -patch
tags 377618 wontfix
severity 377618 wishlist
stop and no thanks

On Thu, Jul 20, 2006 at 01:13:45PM +0200, Thomas Huriaux wrote:
<snipp> 
> No, the argument of the priority is not valid. The lowest the priority
> is, the more experienced the user is expected to be. An experienced user
> usually knows where to find the relevant doc, and expects to find it at
> the right place.
> Moreover, as I said in my previous mail, you should use debconf to
> _configure_ the package, not to tell the user he/she can configure it.
> I therefore attach a patch to configure with debconf the two related
> items. Please check it carefully as I made it quickly.

big NACK,
this is a real policy violation,
one is not allowed to change configfiles with debconf.
you would need to put it into /etc/defaults/logcheck.

and as you currently failed to convince me politely,
downgrading this "bug".

this debconf messages were added way before the logcheck team formed
and we cleaned them up already a lot. the second note will soon
be phase out.
 
 
> See also policy 3.9.1:
> 
>   Packages should try to minimize the amount of prompting they need to do
> 
> You seem to use debconf only because it is "more effective"

please notice the subtle _should_
 
-- 
maks



Tags removed: patch Request was from maximilian attems <maks@sternwelten.at> to control@bugs.debian.org. Full text and rfc822 format available.

Tags added: wontfix Request was from maximilian attems <maks@sternwelten.at> to control@bugs.debian.org. Full text and rfc822 format available.

Severity set to `wishlist' from `minor' Request was from maximilian attems <maks@sternwelten.at> to control@bugs.debian.org. Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian logcheck Team <logcheck-devel@lists.alioth.debian.org>:
Bug#377618; Package logcheck. Full text and rfc822 format available.

Acknowledgement sent to Thomas Huriaux <thomas.huriaux@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian logcheck Team <logcheck-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #33 received at 377618@bugs.debian.org (full text, mbox):

From: Thomas Huriaux <thomas.huriaux@gmail.com>
To: maximilian attems <maks@sternwelten.at>
Cc: 377618@bugs.debian.org
Subject: Re: [Logcheck-devel] Bug#377618: logcheck: Please do not abuse debconf
Date: Thu, 20 Jul 2006 14:52:53 +0200
[Message part 1 (text/plain, inline)]
maximilian attems <maks@sternwelten.at> (20/07/2006):
> tags 377618 -patch
> tags 377618 wontfix
> severity 377618 wishlist
> stop and no thanks
> 
> On Thu, Jul 20, 2006 at 01:13:45PM +0200, Thomas Huriaux wrote:
> <snipp> 
> > No, the argument of the priority is not valid. The lowest the priority
> > is, the more experienced the user is expected to be. An experienced user
> > usually knows where to find the relevant doc, and expects to find it at
> > the right place.
> > Moreover, as I said in my previous mail, you should use debconf to
> > _configure_ the package, not to tell the user he/she can configure it.
> > I therefore attach a patch to configure with debconf the two related
> > items. Please check it carefully as I made it quickly.
> 
> big NACK,
> this is a real policy violation,
> one is not allowed to change configfiles with debconf.
> you would need to put it into /etc/defaults/logcheck.

I don't see any policy violation. I just copy/pasted and adapted the
example in debconf-devel(7). If I missed something, please consider
fixing it and not just marking the bug as wontfix.
What you are saying about /etc/default/ is for init scripts, as far as I
understand the policy.

> and as you currently failed to convince me politely,
> downgrading this "bug".

I fail to find where I haven't been polite. I have used a direct and
not-flourished style, that's all. If I've said something inappropriate,
believe me, I'm sorry about it.

> > See also policy 3.9.1:
> > 
> >   Packages should try to minimize the amount of prompting they need to do
> > 
> > You seem to use debconf only because it is "more effective"
> 
> please notice the subtle _should_

Sure, but my bug was not "serious", it was only "minor".

-- 
Thomas Huriaux
[signature.asc (application/pgp-signature, inline)]

Reply sent to martin f krafft <madduck@debian.org>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Thomas Huriaux <thomas.huriaux@gmail.com>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #38 received at 377618-done@bugs.debian.org (full text, mbox):

From: martin f krafft <madduck@debian.org>
To: 377618-done@bugs.debian.org
Subject: independent fix
Date: Sun, 23 Jul 2006 07:52:38 +0100
[Message part 1 (text/plain, inline)]
I have fixed this independently by moving install-note to
NEWS.Debian because I clearly saw debconf abuse going on.
apt-listchanges is configured to display NEWS files by default, so
the solution should now make everyone happy.

-- 
Please do not send copies of list mail to me; I read the list!
 
 .''`.     martin f. krafft <madduck@debian.org>
: :'  :    proud Debian developer and author: http://debiansystem.info
`. `'`
  `-  Debian - when you have better things to do than fixing a system
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian logcheck Team <logcheck-devel@lists.alioth.debian.org>:
Bug#377618; Package logcheck. Full text and rfc822 format available.

Acknowledgement sent to Todd Troxell <ttroxell@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian logcheck Team <logcheck-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #43 received at 377618@bugs.debian.org (full text, mbox):

From: Todd Troxell <ttroxell@debian.org>
To: Thomas Huriaux <thomas.huriaux@gmail.com>, 377618@bugs.debian.org
Subject: Re: [Logcheck-devel] Bug#377618: logcheck: Please do not abuse debconf
Date: Tue, 25 Jul 2006 21:43:42 -0500
On Mon, Jul 10, 2006 at 01:32:46PM +0200, Thomas Huriaux wrote:
> Package: logcheck
> Severity: minor
> 
> Hi,
> 
> You are using two debconf notes which really look like a debconf abuse
> (from debconf-devel(7): "It should be used only for important notes that
> the user really should see, since debconf will go to great pains to make
> sure the user sees it").
>
> The first note (logcheck/install-note) should probably be moved to a
> README.Debian file or somewhere else in the documentation. Or you should
> really use debconf to configure these two options (report level and
> address) instead of displaying a note.
> The second note (logcheck/changes) can probably be removed. It no longer
> concerns supported transitions in Debian: the version 1.2.39 is in
> sarge, and if I understand correctly, it is for transitions from a
> version < 1.2.3. However, this note should have been in a NEWS.Debian
> file.

I tend to agree with this somewhat.  The note is uncritical.  Anyway, the first
thing users seem to do after installing a new package is to check out
/usr/share/doc/<pkg>/Readme* -- as they should.

The logcheck/changes note should stick around for backporting reasons, as
maks mentioned.

Any other opinions?

-- 
Todd Troxell
http://rapidpacket.com/~xtat



Information forwarded to debian-bugs-dist@lists.debian.org, Debian logcheck Team <logcheck-devel@lists.alioth.debian.org>:
Bug#377618; Package logcheck. Full text and rfc822 format available.

Acknowledgement sent to Peter Eisentraut <peter_e@gmx.net>:
Extra info received and forwarded to list. Copy sent to Debian logcheck Team <logcheck-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #48 received at 377618@bugs.debian.org (full text, mbox):

From: Peter Eisentraut <peter_e@gmx.net>
To: 377618@bugs.debian.org
Subject: Re: Bug#377618: logcheck: Please do not abuse debconf
Date: Tue, 15 Aug 2006 23:28:26 +0200
I had never installed logcheck before today, and the first thing it does 
is pop up a debconf note to the effect "If you want to configure this 
package, edit the configuration file.  For more information, read the 
documentation." -- No kidding.  I appreciate that you guys are 
addressing this.

I don't see, however, where this claimed fix is.  The version in 
unstable (1.2.47) still contains both notes, which should be moved to 
README.Debian and NEWS.Debian, respectively.



Tags added: pending Request was from martin f.krafft <madduck@debian.org> to control@bugs.debian.org. Full text and rfc822 format available.

Tags removed: wontfix Request was from martin f.krafft <madduck@debian.org> to control@bugs.debian.org. Full text and rfc822 format available.

Tags added: pending Request was from martin f.krafft <madduck@debian.org> to control@bugs.debian.org. Full text and rfc822 format available.

Reply sent to madduck@debian.org (martin f. krafft):
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Thomas Huriaux <thomas.huriaux@gmail.com>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #59 received at 377618-close@bugs.debian.org (full text, mbox):

From: madduck@debian.org (martin f. krafft)
To: 377618-close@bugs.debian.org
Subject: Bug#377618: fixed in logcheck 1.2.48
Date: Tue, 17 Oct 2006 01:02:12 -0700
Source: logcheck
Source-Version: 1.2.48

We believe that the bug you reported is fixed in the latest version of
logcheck, which is due to be installed in the Debian FTP archive:

logcheck-database_1.2.48_all.deb
  to pool/main/l/logcheck/logcheck-database_1.2.48_all.deb
logcheck_1.2.48.dsc
  to pool/main/l/logcheck/logcheck_1.2.48.dsc
logcheck_1.2.48.tar.gz
  to pool/main/l/logcheck/logcheck_1.2.48.tar.gz
logcheck_1.2.48_all.deb
  to pool/main/l/logcheck/logcheck_1.2.48_all.deb
logtail_1.2.48_all.deb
  to pool/main/l/logcheck/logtail_1.2.48_all.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 377618@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
martin f. krafft <madduck@debian.org> (supplier of updated logcheck package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.7
Date: Sun,  8 Oct 2006 17:15:43 +0200
Source: logcheck
Binary: logcheck logtail logcheck-database
Architecture: source all
Version: 1.2.48
Distribution: unstable
Urgency: low
Maintainer: Debian logcheck Team <logcheck-devel@lists.alioth.debian.org>
Changed-By: martin f. krafft <madduck@debian.org>
Description: 
 logcheck   - mails anomalies in the system logfiles to the administrator
 logcheck-database - database of system log rules for the use of log checkers
 logtail    - Print log file lines that have not been read
Closes: 355701 359787 372286 377139 377605 377618 377874 378976 379131 379215 381983 383243 386768 388924
Changes: 
 logcheck (1.2.48) unstable; urgency=low
 .
   [ maximilian attems ]
   * ignore.d.server/postfix: Fix cleanup rule and remove duplicate.
     Thanks Paul Aurich <paul+debian@aurich.com> (closes: 378976)
   * Updated debconf translations:
     - fr.po thanks Michel Grentzinger <mic.grentz@online.fr> (closes: 379215)
     - nl.po thanks Frans Pop <elendil@planet.nl> (closes: 377605)
     - it.po thanks Luca Monducci <luca.mo@tiscali.it> (closes: 377874)
   * violations.ignore.d/logcheck-ssh, violations.ignore.d/logcheck-postfix:
     Move to postfix rules to the later. (closes: 377139)
   * ignore.d.server/courier: Ignore authdaemon ldap reconnections.
     Thanks Tilman Koschnick <til@subnetz.org> for the patch (closes: 372286).
   * ignore.d.server/sa-exim: Add 2 rules for sa-exim. Thanks
     Ross Boylan <ross@biostat.ucsf.edu> (closes: 359787).
   * ignore.d.workstation/kernel: Add more rules for swsusp.
   * ignore.d.workstation/kernel: Ignore loop module loading.
   * Add catalan debconf translation (closes: 379131)
     - Thanks for ca.po to Jordà Polo <jorda@ettin.org>
   * ignore.d.workstation/kernel: Ignore oprofile loading.
   * ignore.d.workstation/kernel: Ignore removable device plugging.
   * ignore.d.server/dhclient: Ignore recorded leas output and bound renewal.
   * violations.ignore.d/logcheck-login: Ignore successful root logins on tty's.
   * ignore.d.workstation/ifplugd: Ignore link beat loose.
   * ignore.d.workstation/kernel: detto.
   * debian/logcheck-database.postinst: Make logcheck-database piuparts clean,
     on upgrade. Remove moved configfiles if they are unchanged.
     Thanks Lars Wirzenius <liw@iki.fi> for report (closes: #355701).
   * Remove old useless logcheck/changes low priority debconf template.
   * Remove logcheck/install-note as logcheck.conf is self explantory.
     (closes: 377618) Thanks Thomas Huriaux <thomas.huriaux@gmail.com>.
   * Move logcheck/changes retroactively to logcheck.News. Thus cleanup
     logcheck.control, no debconf left (closes: #388924).
   * logcheck-database.config fix bashism.
 .
   [ martin f. krafft ]
   * moved po-debconf build-dep to arch-dependent list due to clean target.
   * removed logcheck debconf files, only logcheck-database has debconf.
   * ignore.d.server/pdns: ignore failure to get SOA serial from supermasters
     that send wrong notifies.
   * ignore.d.server/cron-apt: fixed several rules for corner cases.
   * ignore.d.server/postfix: added rule for server greeting timeout.
   * ignore.d.server/postfix: also add msgid status messages by cleanup daemon.
   * ignore.d.server/proftpd: fixed rule to ignore unknown user logins.
   * ignore.d.server/spamd: fixed rule for config location message.
   * ignore.d.server/ssh: duplicate possible breakin messages from
     violations.ignore.d.
   * ignore.d.server/ssh: duplicate invalid user messages from
     violations.ignore.d, and also cater for zero-length usernames.
   * ignore.d.server/smartd, violations.ignore.d/logcheck-smartd: revert to
     reporting drastic changes in attributes.
   * ignore.d.server/smartd, violations.ignore.d/logcheck-smartd: now works
     with almost arbitrary disk names.
   * ignore.d.server/kernel: partially undo link status message filter, now
     only filters up messages, not the down ones. By nature of the link status,
     the messages will come in pairs or not at all anyway.
   * ignore.d.server/dovecot: ignoring inactivity logouts.
   * ignore.d.server/pdns: ignoring message about new superslave zones.
   * ignore.d.server/spamd: correcting typo in SIGCHLD cleanup rule.
   * ignore.d.server/ssh: ignoring ssh_msg_recv failure messages.
   * ignore.d.server/pdns: ignore messages about not being authoritative for
     just about anything.
   * ignore.d.server/cron-apt: fixed rule to properly treat lines with packages
     whose names have dots (closes: #381983).
   * Do not remove the logcheck user on purge as it may still own files
     (closes: #383243).
   * Updated nl debconf translation, thanks to Frans Pop (closes: #386768).
   * Added patches by Elmar Hoffman to ignore power on time usage attribute and
     messages about self-tests.
Files: 
 68491a5e081da4a7dad219824667d421 753 admin optional logcheck_1.2.48.dsc
 18154697cf5c925ab9bfc31321b147ba 120619 admin optional logcheck_1.2.48.tar.gz
 807c525fc2cb87bf0e6cca5709fdff26 53688 admin optional logcheck_1.2.48_all.deb
 6d406dd6ef6aa5344723d8180e0f4b8e 76216 admin optional logcheck-database_1.2.48_all.deb
 ff68a4c38a0d09227c1fd651ec27d9ba 36504 admin optional logtail_1.2.48_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.5 (GNU/Linux)

iD8DBQFFNIqQIgvIgzMMSnURAiqfAJ9xOP2RoDyWENPECakEwXawEeisXgCfWzN5
tAU23V6bShkv17ac5Ebg/OQ=
=5m/x
-----END PGP SIGNATURE-----




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Sun, 24 Jun 2007 18:53:42 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Fri Apr 18 04:17:04 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.